/*
 * code to dump data in hex and ascii display
 * 
 * Richard Johnson <thief@exploit.us>
 */

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/mman.h>

#ifdef FULL
void banner()
{
	printf("hex/ascii binary viewer\n"); 
	printf("Richard Johnson <rjohnson@uninformed.org>\n");
	return;
}


int main(int argc, char **argv) 
{
	int fd;
	size_t size;
	unsigned char *buf;
	
	banner();
	
	if(argc == 1) 
	{
		printf("usage: %s <file>\n", argv[0]);
		return -1;
	}

	if((fd = open(argv[1], O_RDONLY)) < 0) 
	{
		perror("open");
		return -1;
		
	}

	size = lseek(fd, 0, SEEK_END);
	buf = (char *)mmap(NULL, size, PROT_READ, MAP_PRIVATE, fd, 0);
	
	hexdum(buf, size);

	munmap(buf, size);
	close(fd);
}
#endif

int hexdump(unsigned char *buf, int size)
{
	int i, j;

	for (i = 0; i < size; i += 16) 
	{
		printf("\n%08x: ", i);
		
		for (j = 0; j < 16; j++)
		{
			if ( i+j < size ) 
				printf("%02X ", buf[i+j]);
			else
				printf("  ");
	
		}

		printf(" ");
		
		for (j = 0; j < 16; j++)
		{
			unsigned char ch = (i+j < size) ? buf[i+j] : ' ';
			if ((ch < 0x20) || (ch > 0x7e)) 
				ch = '.';
			printf("%c", ch);
		}
	}
	
	printf("\n\n");
	return size;
}



